<root main_tree_to_execute="MainTree">
  <BehaviorTree ID="MainTree">
    <RecoveryNode number_of_retries="10" name="NavigateRecovery">
      <PipelineSequence name="NavigateWithReplanning">
        <RateController hz="2.0">
          <RecoveryNode number_of_retries="1" name="ComputePathToPose">
            <Fallback>
              <ReactiveSequence>
                <Inverter>
                  <PathExpiringTimer seconds="10" path="{path}" />
                </Inverter>
                <Inverter>
                  <GlobalUpdatedGoal />
                </Inverter>
                <IsPathValid server_timeout="10" path="{path}" />
              </ReactiveSequence>
              <ComputePathToPose goal="{goal}" path="{path}" planner_id="GridBased" />
            </Fallback>
            <!-- <Sequence name="ClearLocalAndWait"> -->
              <ClearEntireCostmap name="ClearGlobalCostmap-Context" service_name="global_costmap/clear_entirely_global_costmap" />
              <!-- <Wait wait_duration="5" />
            </Sequence> -->
          </RecoveryNode>
        </RateController>
        <RecoveryNode number_of_retries="3" name="FollowPath">
          <FollowPath path="{path}" controller_id="FollowPath" />
          <ClearEntireCostmap name="ClearLocalCostmap-Context" service_name="local_costmap/clear_entirely_local_costmap" />
        </RecoveryNode>
      </PipelineSequence>
      <ReactiveFallback name="RecoveryFallback">
        <GoalUpdated />
        <RoundRobin name="RecoveryActions">
          <!-- <Sequence name="ClearingActions"> -->
            <ClearEntireCostmap name="ClearLocalCostmap-Subtree" service_name="local_costmap/clear_entirely_local_costmap" />
            <ClearEntireCostmap name="ClearGlobalCostmap-Subtree" service_name="global_costmap/clear_entirely_global_costmap" />
            <!-- <Wait wait_duration="5" />
          </Sequence> -->
          <Spin spin_dist="1.57"/>
          <Wait wait_duration="5"/>
          <BackUp backup_dist="0.15" backup_speed="0.025"/>
        </RoundRobin>
      </ReactiveFallback>
    </RecoveryNode>
  </BehaviorTree>
</root>